/*----------------------------------------------------------------------------

	ex_appl.cpp
	Copyright 1997 Sumus Computing Incorporated, All Rights Reserved.

----------------------------------------------------------------------------*/

#include "ex_appl.h"
#include "atreevw.h"


//----------------------------------------------------------------------------

class AFrameWindow: public BWindow 
{
public:
	AFrameWindow(const BRect& rect,char const* title);
	~AFrameWindow();

	virtual bool QuitRequested();
};


AFrameWindow::AFrameWindow(const BRect& rect,char const* title)
  :	BWindow(rect,title,B_TITLED_WINDOW,0)
{
}


AFrameWindow::~AFrameWindow()
{
}


bool AFrameWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}


//----------------------------------------------------------------------------

class AApplTreeView: public ATreeView
{
public:
	AApplTreeView(	float a_itemHeight,
					BRect frame,char const* name,
					ulong resizingMode = B_FOLLOW_LEFT|B_FOLLOW_TOP, 
					ulong flags		 = B_WILL_DRAW|B_NAVIGABLE|B_FRAME_EVENTS)
	  :	ATreeView(frame,name,resizingMode,flags),
		itemHeight(a_itemHeight)
	{
	}

protected:
	float itemHeight;
	virtual float ItemHeight() { return itemHeight; }
};


//----------------------------------------------------------------------------

AApplication::AApplication(float itemHeight)
  :	BApplication('????')
{
	BRect rect(80,60,200,400);

	frameWindow = new AFrameWindow(rect,"TreeView Example");
	
	rect.OffsetTo(0,0);	
	rect.right	-= B_V_SCROLL_BAR_WIDTH+1;
	rect.bottom	-= B_H_SCROLL_BAR_HEIGHT+1;

	treeView	= new AApplTreeView(itemHeight,rect,"",B_FOLLOW_ALL_SIDES);
	scrollView	= new BScrollView("",treeView,B_FOLLOW_ALL_SIDES,0,true,true,true);
	
	frameWindow->AddChild(scrollView);
	frameWindow->Show();
}


void AApplication::ReadyToRun()
{
	AddToTreeView();
}


//-- eof ---------------------------------------------------------------------
