/*----------------------------------------------------------------------------

	example1.cpp
	Copyright 1997 Sumus Computing Incorporated, All Rights Reserved.
	
----------------------------------------------------------------------------*/
// Tree view example 1 (simple)

#include "ex_appl.h"


//----------------------------------------------------------------------------


class AStringTreeItem: public ATreeItem
{
public:
	AStringTreeItem(char const* a_string);
	~AStringTreeItem();

	virtual char const* GetLabel() const;

protected:
	char *string;
};


AStringTreeItem::AStringTreeItem(char const* a_string)
  :	ATreeItem(), string(NULL)
{
	string = strdup(a_string ? a_string : "");
}


AStringTreeItem::~AStringTreeItem()
{
	delete string;
}


inline char const* AStringTreeItem::GetLabel() const
{
	return string;
}


//----------------------------------------------------------------------------


class ExampleApplication: public AApplication 
{
public:
	ExampleApplication()	{}

	virtual void  AddToTreeView();
};


void ExampleApplication::AddToTreeView()
{
	treeView->Lock();
	
	for(long l1=0; l1<4; l1++)
	{
		ATreeItem *i1 = new AStringTreeItem("layer 1");
		treeView->Root().AddItem(*i1);

		for(long l2=0; l2<5; l2++)
		{
			ATreeItem *i2 = new AStringTreeItem("layer 2");
			i1->AddItem(*i2);

			for(long l3=0; l3<5; l3++)
			{
				ATreeItem *i3 = new AStringTreeItem("layer 3");
				i2->AddItem(*i3);

				for(long l4=0; l4<5; l4++)
				{
					ATreeItem *i4 = new AStringTreeItem("layer 4");
					i3->AddItem(*i4);
				}
			}
		}
	}

	treeView->Unlock();
}


int main(void)
{
	return ExampleApplication().Run();	
}


//-- eof ---------------------------------------------------------------------
